<!-- team 团队 -->
<template>
    <div
        class="full-page"
        element-loading-text="数据加载中..."
        element-loading-spinner="el-icon-loading"
        element-loading-background="rgba(255,255,255, 0.5)"
        v-loading.fullscreen.lock="markLoading"
    >
        <el-form label-width="auto" :model="parameter">
            <el-row :gutter="10">
                <el-col :span="5">
                    <el-form-item label="事件编号">
                        <el-input
                            clearable
                            v-model="querys[0].value"
                            placeholder="请输入事件编号"
                        ></el-input>
                    </el-form-item>
                </el-col>
                <el-col :span="5">
                    <el-form-item label="事件名称">
                        <el-input
                            clearable
                            v-model="querys[1].value"
                            placeholder="请输入事件名称"
                        ></el-input>
                    </el-form-item>
                </el-col>
                <el-col :span="5">
                    <el-form-item label="事件分类">
                        <el-select
                            stylEventRegistration="width: 100%"
                            v-model="querys[2].value"
                            clearable
                            placeholder="请选择事件分类"
                        >
                            <el-option
                                v-for="item in sjflList"
                                :key="item.value"
                                :label="item.name"
                                :value="item.value"
                            >
                            </el-option>
                        </el-select>
                    </el-form-item>
                </el-col>
                <el-col :span="5">
                    <el-form-item label="事件来源">
                        <el-select
                            stylEventRegistration="width: 100%"
                            v-model="querys[3].value"
                            clearable
                            placeholder="请选择事件来源"
                        >
                            <el-option
                                v-for="item in sjlyList"
                                :key="item.value"
                                :label="item.name"
                                :value="item.value"
                            >
                            </el-option>
                        </el-select>
                    </el-form-item>
                </el-col>
                <el-col :span="2">
                    <el-button
                        type="primary"
                        @click="getData(1)"
                        icon="el-icon-search"
                        >查询</el-button
                    >
                </el-col>
            </el-row>
        </el-form>
        <div style="margin-bottom: 10px" ref="btnPanel"></div>
        <div class="table-wrapper">
            <el-table
                height="100%"
                row-key="id"
                align="center"
                :data="tableData"
                :cell-style="{'text-align': 'center'}"
                style="min-width: 100%; overflow: auto"
                :header-cell-style="{'text-align': 'center'}"
                v-loading="loading"
                @selection-change="handleSelectionChange"
                ref="table"
            >
                <!-- <el-table-column type="selection" width="55" align="center" :selectable="selectable"></el-table-column> -->
                <el-table-column
                    type="index"
                    width="60"
                    label="序号"
                ></el-table-column>
                <el-table-column
                    width="190px"
                    prop="eventName"
                    label="事件名称"
                ></el-table-column>
                <el-table-column
                    width="140px"
                    prop="eventCode"
                    label="事件编号"
                ></el-table-column>
                <el-table-column
                    width="150px"
                    prop="eventType"
                    show-overflow-tooltip
                    label="事件类型"
                    align="center"
                >
                    <template #default="{row}">
                        {{ getDictName('sjfx-sjfl', row.eventType) }}
                    </template>
                </el-table-column>
                <el-table-column
                    width="150px"
                    prop="eventSource"
                    show-overflow-tooltip
                    label="事件来源"
                    align="center"
                >
                    <template #default="{row}">
                        {{ getDictName('sjly', row.eventSource) }}
                    </template>
                </el-table-column>
                <el-table-column
                    width="140px"
                    prop="hours"
                    label="处置时长（h）"
                ></el-table-column>
                <el-table-column
                    prop="address"
                    label="详细地址"
                ></el-table-column>
                <el-table-column
                    width="180px"
                    prop="eventProduceTime"
                    label="时间"
                ></el-table-column>
                <!-- <el-table-column width="100" label="操作">
          <template v-slot="{ row }">
            <el-link
              type="danger"
              :underline="false"
              class="cloumn-btn"
              @click="handleDelete('delete', row)"
              v-methodauth="'TeamFilingManage_delete'"
            >删除</el-link>
          </template>
        </el-table-column> -->
            </el-table>
        </div>
        <pagination
            ref="paginationPanel"
            style="margin-top: 10px"
            :pageResult="pageResult"
            @size-change="handleSizeChange"
            @current-change="handleCurrentChange"
        />
    </div>
</template>
<script>
import pagination from '@/components/pagination'
import {TableMixin} from '@/mixins/tableMixin'
import DependentAnalysis from '@/api/FeedbackArchiving/DependentAnalysis.js'
import utils from '@/utils.js'
import dictUtils from '@/components/dict/DictSelectUtils.js'
export default {
    name: 'DependentAnalysis',
    components: {
        pagination,
    },
    mixins: [TableMixin],
    data() {
        return {
            markLoading: false,
            tableMaxHeight: 400,
            tableData: [],
            pageResult: {
                page: 1,
                pageSize: 20,
                total: 0,
            },
            querys: [
                {
                    group: 'main',
                    operation: 'LIKE',
                    parentGroup: '',
                    property: 'eventCode',
                    relation: 'AND',
                    value: '',
                },
                {
                    group: 'main',
                    operation: 'LIKE',
                    parentGroup: '',
                    property: 'eventName',
                    relation: 'AND',
                    value: '',
                },
                {
                    group: 'main',
                    operation: 'EQUAL',
                    parentGroup: '',
                    property: 'eventType',
                    relation: 'AND',
                    value: '',
                },
                {
                    group: 'main',
                    operation: 'EQUAL',
                    parentGroup: '',
                    property: 'eventSource',
                    relation: 'AND',
                    value: '',
                },
            ],
            reqData: {
                querys: [],
                pageBean: {
                    page: 1,
                    pageSize: 20,
                    showTotal: true,
                },
            },
            tableLoading: false,
            deleteIds: '',
            parameter: {
                size: 20,
                page: 1,
            },
            sjlyList: [], // 事件来源 下拉
            sjflList: [], // 事件来源 下拉
        }
    },
    created() {
        this.sjlyList = dictUtils.getDictItemsFromCache('sjly')
        this.sjflList = dictUtils.getDictItemsFromCache('sjfx-sjfl')

        this.getData()
    },
    methods: {
        selectable(row) {
            if (row.isDele === '1') {
                return false
            } else {
                return true
            }
        },
        //获取数据
        getData(page) {
            if (page) {
                this.reqData.pageBean.page = page
            }
            this.reqData.querys = []
            if (this.querys[0].value) {
                this.reqData.querys.push(this.querys[0])
            }
            if (this.querys[1].value) {
                this.reqData.querys.push(this.querys[1])
            }
            if (this.querys[2].value) {
                this.reqData.querys.push(this.querys[2])
            }
            if (this.querys[3].value) {
                this.reqData.querys.push(this.querys[3])
            }
            this.tableLoading = true
            DependentAnalysis.dataQuery(this.reqData, (res) => {
                this.pageResult.total = res.total
                this.tableLoading = false
                this.tableData = res.rows
                // this.tableData.forEach(e => {
                //     this.fljbList.forEach(f => {
                //         if (e.level == f.value) {
                //             e.levelName = f.name
                //         }
                //     })
                // })
            })
        },
        //获取删除数据id集合
        handleSelectionChange(val) {
            let arr = val.map((item) => item.id)
            this.deleteIds = arr.join(',')
            console.log(this.deleteIds)
        },
        //删除
        handleDelete(type, val) {
            console.log(val)
            this.$confirm('确认删除吗？', this.$t('common.tips'), {
                confirmButtonText: this.$t('common.confirm'),
                cancelButtonText: this.$t('common.cancel'),
                type: 'warning',
            }).then(() => {
                this.markLoading = true
                if (type === 'delete') {
                    DependentAnalysis.blackListDetele([val.id], (res) => {
                        if (res.state) {
                            this.getData()
                            this.$message.success('删除成功')
                            this.markLoading = false
                        } else {
                            this.markLoading = false
                        }
                    })
                } else {
                    DependentAnalysis.blackListDetele(this.deleteIds, (res) => {
                        if (res.state) {
                            this.getData()
                            this.$message.success('删除成功')
                            this.markLoading = false
                        } else {
                            this.markLoading = false
                        }
                    })
                }
            })
        },
        handleSizeChange(val) {
            this.reqData.pageBean.pageSize = val
            this.getData()
        },
        handleCurrentChange(val) {
            this.reqData.pageBean.page = val
            this.getData()
        },
        getDictName(code, value) {
            return utils.getDictName(code, value)
        },
    },
}
</script>
<style lang='scss' scoped>
@import '~@/assets/css/element-variables.scss';
@import '~@/assets/css/common.scss';

.table-wrapper {
    height: calc(100% - 170px);
}
/deep/ .el-form-item {
    display: flex;
}
/deep/ .el-form-item__content {
    margin-left: 0px !important;
}
/deep/ .el-col {
    margin: 0px !important;
}
</style>
